<?php

namespace app\common;

use think\Request;

class ZhifuFm extends Pay
{

	public function requestForm($className,$outTradeNo,$subject,$totalAmount,$paytype='')
    {
		$apiurl = $this->account->params->apiUrl;
        $key = $this->account->params->key;
        $params = array();
        $params['merchantNum'] = $this->account->params->merchantNum;
        $params['payType'] = $paytype;
        $params['notifyUrl'] = Request::instance()->domain() . '/pay/notify/' . $className;
        $params['returnUrl'] = Request::instance()->domain() . '/pay/page/' . $className;
		$params['orderNo'] = $outTradeNo;
		$params['subject'] = $subject;
        $params['returnType'] = "page";
		$params['amount'] = number_format($totalAmount,2,'.','');
        $sign = $this->sign(array($params['merchantNum'],$params['orderNo'], $params['amount'], $params['notifyUrl'], $key));
        $params['sign'] =$sign;
        //拼装 form 表单
        $form = $this->setForm($apiurl, $params);
        $this->code = 0;
        $obj = new \stdClass();
        $obj->pay_url = $form;
        $obj->content_type = 3;
        return $obj;
    }

    /**
     * @param $data
     * @return string
     */
    public function setForm($apiurl, $data)
    {
        $html = "<form id='pay_form' class=\"form-inline\" method=\"post\" action=\"{$apiurl}\">";
        foreach ($data as $k => $v) {
            $html .= "<input type=\"hidden\" name=\"$k\" value=\"$v\">";
        }
        $html .= "</form>";
        $html .= "<script>document.forms['pay_form'].submit();</script>";
        return $html;
    }

    /**
     * 页面回调
     */
    public function page_callback($params, $order)
    {
        header("Location:" . url('/orderquery', ['orderid' => $order->trade_no]));
		exit;
    }

    /**
     * 服务器回调
     */
    public function notify_callback($params, $order)
    {
        //var_dump($params);die;

        
        $key = $this->account->params->key;
        $merchantNum = $this->account->params->merchantNum;
        $sign = $this->sign(array($params['state'], $merchantNum, $params['orderNo'], $params['amount'], $key));
        if ($sign == $params['sign']) {

            if ($params["state"] == "1") {
                // 金额异常检测
                if ($order->total_price != $params['amount']) {
                    record_file_log('zhifufm_notify_error', '金额异常！' . "\r\n" . $order->trade_no . "\r\n订单金额：{$order->total_price}，已支付：{$params['actualPayAmount']}");
                    die('amount error');
                }

                $this->completeOrder($order);
                echo 'success';
                return true;
            } else {
                exit('state error');
            }

        }else{
            record_file_log('zhifufm_notify_fail','验签失败'.$order->trade_no);
            exit('sign error');
        }
    }

    //签名生成
    protected function sign($data_arr) {
        return md5(join('',$data_arr));
    }

  
}